import { Direction } from './types';
/**
 * Returns the closest element to the current element when trying to navigate in the provided direction. Returns
 * undefined, if there is not element in the given direction.
 *
 * @param activeElement The currently selected element
 * @param elements The list of all elements that can be navigated to
 * @param direction The direction in which to navigate
 */
export declare function getElementInDirection(activeElement: HTMLElement, elements: HTMLElement[], direction: Direction): HTMLElement | undefined;
/**
 * Returns DOMRect like object containing horizontal X and vertical Y coordinates from and HTMLElement.
 * Handles use-cases for getBoundingClientRect when the return type can be either
 * a ClientRect or DOMRect object type.
 *
 * @param element The currently selected element
 */
export declare function getBoundingRectFromElement(element: HTMLElement): DOMRect;
